package question1;
import java.util.Set;

/** Le Patron Diviseur (<i>Splitter</i>) 'divise' le message envoy
 */
public interface DiviseurI {

  /** Envoi d'une table de messages. 
   * @param messages la table des messages
   * @throws Exception si la table est nulle, et si depuis le dernier envoi tous les messages n'ont pas t lus. 
   */
  void envoyer(Message... messages) throws Exception;
  
  /** Lecture d'un message.
   * @param index l'indice du message
   * @throws Exception si le message n'existe pas, ou si cet index est erron
   */
  Message lire(int index) throws Exception;
  
  /** Efface la dernire table des messages envoye. 
   * Une exception est leve si tous les messages n'ont pas t lus
   * @throws Exception si depuis le dernier envoi tous les lments n'ont pas t lus. 
   */
  void vider() throws Exception;
  
  /** Obtention d'un ensemble contenant les indices des messages lus depuis le dernier envoi.
   * @return un ensemble d'indices
   * @throws Exception si aucun envoi n'a eu lieu. 
   */
  Set<Integer> messagesNonLus() throws Exception;
  
}
