package question1;

import java.util.Set;
import java.util.TreeSet;
import java.util.concurrent.*;
import java.util.Random;

public class TestDiviseur extends junit.framework.TestCase{
 
  public void testScenario1() throws Exception{
    final DiviseurI d = new Diviseur("d");
    Message msg0 = new Message("zero");
    Message msg1 = new Message("un");
    Message msg2 = new Message("deux");
    Message msg3 = new Message("trois");
    Message msg4 = new Message("quatre");
    
    d.envoyer(msg0,msg1,msg2,msg3,msg4); // envoi dune table de 5 messages
    Message msg = d.lire(2);            // lecture de llment (msg) dindice 2
    assertEquals("deux",msg.contenu());
    Set<Integer> set = d.messagesNonLus();
    assertTrue(set.contains(0));assertTrue(set.contains(1));
    assertTrue(set.contains(3));assertTrue(set.contains(4));
    assertEquals(set.size(),4);// soit 4 lments  lire
    
    assertTrue(d.lire(4).contenu().equals("quatre"));
    assertTrue(d.messagesNonLus().size()==3);
    try{
      // nouvel envoi alors qu'il reste des lments  lire
      d.envoyer(new Message("test")); 
      fail("une exception est attendue ici ...");
    }catch(Exception e){}
    for(int i : d.messagesNonLus()){ // pour tous les messages non lus
      msg = d.lire(i);
    }
    msg = d.lire(2);              // une deuxime lecture est possible
    assertTrue(d.messagesNonLus().size()==0);
    d.envoyer(new Message("test0"),new Message("test1"));
    assertTrue(d.messagesNonLus().size()==2);
    try{
      // clear() alors qu'il reste des lments  lire
      d.vider();
      fail("une exception est attendue ici ...");
    }catch(Exception e){}
  }
  
  public void testScenario2() throws Exception{
    final DiviseurI d = new Diviseur("d1");
    try{
      d.lire(0);
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    d.envoyer(new Message("a"),new Message("b"),new Message("c"),new Message("d"));
    try{
      // clear() alors qu'il reste des lments  lire
      d.vider();
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    try{
      // get alors qu'il n'y a rien  lire   
        d.lire(0);
        fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
    d.vider();
    try{
      // aucun envoi n'a eu lieu
      d.messagesNonLus(); 
      fail("une exception est attendue ici ...");
    }catch(Exception e){
    }
  }
  
  public void testScenario3() throws Exception{
    final DiviseurI d = new Diviseur("d");
    d.envoyer(new Message("a"),new Message("b"),new Message("c"),new Message("d"));
    Message msg = d.lire(0);assertEquals("a",msg.contenu());
    msg = d.lire(1);assertEquals("b",msg.contenu());
    msg = d.lire(2);assertEquals("c",msg.contenu());
    msg = d.lire(3);assertEquals("d",msg.contenu());
    assertEquals(0,d.messagesNonLus().size());
    d.envoyer(new Message("a"),new Message("b"));
    assertEquals(2,d.messagesNonLus().size());
    d.lire(1); d.lire(1);
    assertEquals(1,d.messagesNonLus().size());
    d.lire(0);
    assertEquals(0,d.messagesNonLus().size());
    d.envoyer(new Message("a"),new Message("b"),new Message("c"),new Message("d"),new Message("e"));
    assertEquals(5,d.messagesNonLus().size());
    msg = d.lire(0);assertEquals("a",msg.contenu());
    msg = d.lire(1);assertEquals("b",msg.contenu());
    msg = d.lire(2);assertEquals("c",msg.contenu());
    msg = d.lire(3);assertEquals("d",msg.contenu());
    msg = d.lire(4);assertEquals("e",msg.contenu());
    assertEquals(0,d.messagesNonLus().size());
  }
  
  private static class ThreadTestMessagesNonLus implements Runnable{
    private DiviseurI d;
    public ThreadTestMessagesNonLus(DiviseurI diviseur){
      this.d = diviseur;
    }
    public void run(){
      try{
        while(d.messagesNonLus().size()>0){
          Set<Integer> nonLus = d.messagesNonLus();
          System.out.println("d.messagesNonLus() : " + nonLus);
          Thread.sleep(100);
        }
      }catch(Exception e){
        e.printStackTrace();
      }
    }
  }
  
  private static class ThreadTestLireMessage implements Runnable{
    private DiviseurI d;
    private Random random= new Random();
    public ThreadTestLireMessage(DiviseurI Diviseur){
      this.d = Diviseur;
    }
    
    public void run(){
      try{
        while(true){
          Message msg = d.lire(random.nextInt(5));
          System.out.println("msg lu : " + msg.contenu());
          Thread.sleep(10);
        }
      }catch(Exception e){
        
      }
    }
  }
  

  public void testScenario4() throws Exception{
    ExecutorService pool = Executors.newFixedThreadPool(20);
    final DiviseurI d = new Diviseur("d3");
    d.envoyer(new Message("a"),new Message("b"),new Message("c"),new Message("d"));
    pool.execute(new ThreadTestMessagesNonLus(d));
    pool.execute(new ThreadTestMessagesNonLus(d));
    pool.execute(new ThreadTestMessagesNonLus(d));
    pool.execute(new ThreadTestMessagesNonLus(d));
    Thread.sleep(5*1000);
    pool.execute(new ThreadTestLireMessage(d));
    pool.execute(new ThreadTestLireMessage(d));
    pool.execute(new ThreadTestLireMessage(d));
    pool.execute(new ThreadTestLireMessage(d));
    pool.execute(new ThreadTestLireMessage(d));
    pool.execute(new ThreadTestLireMessage(d));
    pool.execute(new ThreadTestLireMessage(d));
    pool.execute(new ThreadTestLireMessage(d));
    Thread.sleep(10*1000);
    pool.shutdown();
  }
    
  
   public void testScenario5() throws Exception{
    final DiviseurI dd = new Diviseur("dd");
    Message msg0 = new Message("zero");
    Message msg1 = new Message("un");
    Message msg2 = new Message("deux");
    Message msg3 = new Message("trois");
    Message msg4 = new Message("quatre");
    
    dd.envoyer(msg0,msg1,msg2,msg3,msg4);
    assertEquals(5,dd.messagesNonLus().size());
    
    final DiviseurI d = new Diviseur("dd"); // persistance
    assertEquals(5,d.messagesNonLus().size());
  }
  
  
   public void testScenario6() throws Exception{
    DiviseurI d = new Diviseur("d");
    Message msg0 = new Message("zero");
    Message msg1 = new Message("un");
    Message msg2 = new Message("deux");
    Message msg3 = new Message("trois");
    Message msg4 = new Message("quatre");
    
    d.envoyer(msg0,msg1,msg2,msg3,msg4); // envoi dune table de 5 messages
    Message msg = d.lire(2);            // lecture de llment (msg) dindice 2
    assertEquals(4, d.messagesNonLus().size());
    d = new Diviseur("d");  // persistence des messages
    assertEquals(4, d.messagesNonLus().size());
    
  }
    
    
  
}
