package question2;

import question1.SplitterI;
import java.util.Set;

import java.io.Serializable;
import java.rmi.Remote;
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;


public class SplitterRMI<M extends Serializable> implements SplitterRMII<M>{

  private SplitterI<M> splitter;
  
  public SplitterRMI(SplitterI<M> splitter)throws RemoteException{
    this.splitter = splitter;
    UnicastRemoteObject.exportObject(this,0);
  }

  public void send(M... messages) throws RemoteException, Exception{
    splitter.send(messages);
  }
  
  public M get(int index) throws RemoteException, Exception{
    return splitter.get(index);
  }
  
  public void clear() throws RemoteException, Exception{
    splitter.clear();
  }
  
  public Set<Integer> unreadMessages() throws RemoteException, Exception{
    return splitter.unreadMessages();
  }
  
}
