package question3;

import java.io.Serializable;
import javax.management.Notification;
import javax.management.NotificationBroadcasterSupport;
import java.util.Set;

public class Splitter<M extends Serializable> extends NotificationBroadcasterSupport implements SplitterMBean<M>{
  private static long sequenceNumber = 0;
  
  private question1.SplitterI<M> splitter;

  public Splitter(question1.SplitterI<M> splitter) throws Exception{
    this.splitter = splitter;
  }

  public void send(M... messages) throws Exception{
    try{
      splitter.send(messages);
    }catch(Exception e){
      sendNotification(new Notification( e.toString(), this,sequenceNumber++));
      throw e;
    }
  }
  
  public M get(int index) throws Exception{
    try{
      return splitter.get(index);
    }catch(Exception e){
      sendNotification(new Notification( e.toString(), this,sequenceNumber++));
      throw e;
    }
  }
  
  public  void clear() throws  Exception{
    try{
      splitter.clear();
    }catch(Exception e){
      sendNotification(new Notification( e.toString(), this,sequenceNumber++));
      throw e;
    }
  }
  
  public Set<Integer> unreadMessages() throws Exception{
    try{
      return splitter.unreadMessages();
    }catch(Exception e){
      sendNotification(new Notification( e.toString(), this,sequenceNumber++));
      throw e;
    }
  }
}