package question1;


public class Message implements IMessage{
  private Object  content;
  private IChannel replyChannel;
  private long    correlationId;
  
  public Message(Object content, IChannel replyChannel, long correlationId){
    this.content       = content;
    this.replyChannel  = replyChannel;
    this.correlationId = correlationId;
    
  }
  
  public Message(IMessage message){
    this.content       = message.getContent();
    this.replyChannel  = message.getReplyChannel();
    this.correlationId = message.getCorrelationId();
    
  }
  
  public Message(String content){
    this(content, null, -1L);
  }
  public IChannel getReplyChannel(){
    return replyChannel;
  }
  
  public Object getContent(){
    return content;
  }
  
  public String toString(){
    return "<" + content + "," + replyChannel + "," + correlationId + ">";
  }
  
  public long getCorrelationId(){
     return correlationId;
  }
    
  public boolean equals(Object obj){
    if(!(obj instanceof Message)) return false;
    Message msg = (Message) obj;
    return content.equals(msg.getContent()) && 
           replyChannel==msg.getReplyChannel() &&
           correlationId==msg.getCorrelationId();
  }

}
