package question1;

/** Canal de communication entre un metteur et un rcepteur.
 * Une file de messages de type LinkedBlockingQueue est utilise.
 * @see java.util.concurrent.LinkedBlockingQueue
 */
public interface IChannel{

  /** Dpt dun message sur ce canal.
    * Appel non bloquant, la file interne a une capacit ad'hoc .
    * @param message le message
    */
  public void put(IMessage message);
  
  /** Rception du message.
   * Le rcepteur est bloqu si aucun message n'est disponible.
   * @param timeOut le dlai de garde au del duquel 
   * une exception (InterruptedException) est leve.
   * @return le message reu
   * @throws Lorsque le dlai de garde est dpass
   */    
  public IMessage get(long timeOut) throws InterruptedException;
}
