package question1;

import java.util.concurrent.*;

public class Channel implements IChannel {
  private BlockingQueue<IMessage> queue;
  private String name;
  
  public Channel(String name){
    this.name = name;
    this.queue = new LinkedBlockingQueue<IMessage>();
  }
  
  public void put(IMessage message){
    try{
      queue.put(message);
    }catch(InterruptedException e){
      throw new RuntimeException("ne devrait pas se produire...");
    }
  }
  
  public IMessage get(long timeout) throws InterruptedException{
    IMessage message = queue.poll(timeout, TimeUnit.MILLISECONDS);
    if(message==null) throw new InterruptedException("waiting time elapses");
    return message;
  }
  
  public String toString(){
    return name;
  }
}
