package question1;

public class TestReturnAddressPattern extends junit.framework.TestCase{

    
    // selon http://www.enterpriseintegrationpatterns.com/ReturnAddress.html
    public void testReturnAddressPattern() throws Exception{
            // les canaux request, Reply1, Reply2
            IChannel requestChannel = new Channel("Request Channel");
            IChannel replyChannel_1 = new Channel("Reply Channel 1");
            IChannel replyChannel_2 = new Channel("Reply Channel 2");

            // Requestor 1 et Requestor 2
            IRequestor requestor_1 = new Requestor(requestChannel,replyChannel_1);
            IRequestor requestor_2 = new Requestor(requestChannel,replyChannel_2);

            // Replier avec un dlai de garde de 10 sec
            Replier replier = new Replier(requestChannel, 10000);

            IMessage message1 = new Message("message_1", replyChannel_1, 1L);
            IMessage message2 = new Message("message_2", replyChannel_2, 2L);

            System.out.println("Envoi de " + message2 + " depuis requestor_2" );
            requestor_2.send(message2);
            System.out.println("Envoi de " + message1 + " depuis requestor_1" );
            requestor_1.send(message1);
            Thread.sleep(2000); // attente de quelques secondes
            IMessage received = requestor_1.receive(10000);
            System.out.println("\n\tRception de " + received + " par requestor_1");
            assertEquals("message_1", received.getContent().toString());
            assertEquals(1L, received.getCorrelationId());
            
            received = requestor_2.receive(10000);
            System.out.println("\n\tRception de " + received + " par requestor_2");
            assertEquals("message_2", received.getContent().toString());
            assertEquals(2L, received.getCorrelationId());


    }
}

