package question1;

import java.util.concurrent.*;

public class ChannelImpl implements Channel {
  private BlockingQueue<Message> queue;
  
  public ChannelImpl(){
    this.queue = new LinkedBlockingQueue<Message>();
  }
  
  public void send(Message message){
    try{
      queue.put(message);
    }catch(InterruptedException e){
      throw new RuntimeException("ne devrait pas se produire");
    }
  }
  
  public Message receive(long timeout) throws InterruptedException{
    Message message = queue.poll(timeout, TimeUnit.MILLISECONDS);
    if(message==null) throw new InterruptedException("waiting time elapses");
    return message;
  }
  
  public String toString(){
    return "ChannelImpl:" + queue;
  }
}
