package question1;

public class TestReturnAddress extends junit.framework.TestCase{

    // selon http://www.enterpriseintegrationpatterns.com/ReturnAddress.html
    public void testReturnAddressPattern() throws Exception{
            // les canaux request, Reply1, Reply2
            Channel requestChannel = new ChannelImpl();
            Channel replyChannel_1 = new ChannelImpl();
            Channel replyChannel_2 = new ChannelImpl();

            // Requestor 1 et Requestor 2
            Requestor requestor_1 = new RequestorImpl(requestChannel,replyChannel_1);
            Requestor requestor_2 = new RequestorImpl(requestChannel,replyChannel_2);

            // Replier avec un dlai de garde de 10 sec
            Replier replier = new ReplierImpl(requestChannel, 10000);

            Message message1 = new MessageImpl("requestor 1", replyChannel_1, 1L);
            Message message2 = new MessageImpl("requestor 2", replyChannel_2, 2L);
            System.out.println("Envoi de " + message2);
            requestor_2.send(message2);
            Thread.sleep(1000); // attente de une seconde
            Message received = requestor_2.receive(20000);
            System.out.println("Rception aprs 2 secondes de " + received);
            assertEquals("requestor 2", received.getContent().toString());

            System.out.println("Envoi de " + message1);
            requestor_1.send(message1);
            Thread.sleep(1000); // attente de une seconde
            received = requestor_1.receive(20000);
            System.out.println("Rception aprs 3 secondes de " + received);
            assertEquals("requestor 1", received.getContent());
    }
}

