package question3;

import javax.management.*;
import java.lang.management.*;
import question1.IChannel;
import question1.IMessage;
import question1.Message;
import question1.IRequestor;
import question1.Requestor;
import question1.IReplier;
import question1.Replier;

public class ChannelAgent implements NotificationListener{

    private static MBeanServer mbs;

    private ChannelMBean requestChannel,replyChannel_1,replyChannel_2; 

    public ChannelAgent(){
        try{
            mbs = ManagementFactory.getPlatformMBeanServer();

            ObjectName name = new ObjectName("Channel:name=requestChannel");
            this.requestChannel = new Channel( new question1.Channel("Request Channel"));
            mbs.registerMBean(this.requestChannel, name); // enregistrement auprs de mbs

            name = new ObjectName("Channel:name=replyChannel_1");
            this.replyChannel_1 = new Channel(new question1.Channel("Reply Channel_1"));
            mbs.registerMBean(this.replyChannel_1, name); 

            name = new ObjectName("Channel:name=replyChannel_2");
            this.replyChannel_2 = new Channel(new question1.Channel("Reply Channel_2"));
            mbs.registerMBean(this.replyChannel_2, name); 

        }catch(Exception e){
            e.printStackTrace();
        }  
    }

    public void handleNotification( Notification notification, Object handback){
        System.out.println("notification " + notification);
    }

    public static void main(String[] args)throws Exception{ 
        ChannelAgent agent = new ChannelAgent();

        Thread.sleep(10000); // attente de quelques secondes, le temps d'excuter jconsole


        IChannel requestChannel = agent.requestChannel;
        IChannel replyChannel_1 = agent.replyChannel_1;
        IChannel replyChannel_2 = agent.replyChannel_2;

        // Requestor 1 et Requestor 2
        IRequestor requestor_1 = new Requestor(requestChannel,replyChannel_1);
        IRequestor requestor_2 = new Requestor(requestChannel,replyChannel_2);

        // Replier avec un dlai de garde de 10 sec
        IReplier replier = new Replier(requestChannel, 10000);

        IMessage message1 = new Message("message_1", replyChannel_1, 1L);
        IMessage message2 = new Message("message_2", replyChannel_2, 2L);

        for(int i=0;i<100;i++){
            System.out.println("Envoi de " + message2 + " depuis requestor_2" );
            requestor_2.send(message2);
            System.out.println("Envoi de " + message1 + " depuis requestor_1" );
            requestor_1.send(message1);
            Thread.sleep(2000); // attente de quelques secondes
            IMessage received = requestor_1.receive(10000);
            System.out.println("\n\tRception de " + received + " par requestor_1");
            assert "message_1".equals(received.getContent().toString());
            assert 1L == received.getCorrelationId();

            received = requestor_2.receive(10000);
            System.out.println("\n\tRception de " + received + " par requestor_2");
            assert "message_2".equals(received.getContent().toString());
            assert 2L == received.getCorrelationId(); 
            Thread.sleep(2000L);
        }
        Thread.sleep(Integer.MAX_VALUE);

    }
    // public static void main(String[] args)throws Exception{ 
    // ChannelAgent agent = new ChannelAgent();
    // Thread.sleep(10000); // attente de quelques secondes
    // ObjectName name = new ObjectName("Channel:name=requestChannel");
    // ChannelAgent requestChannel = (ChannelAgent)
    // MBeanServerInvocationHandler.newProxyInstance(mbs, name,
    // JmxChannelMBean.class, false);
    // requestChannel.addNotificationListener(agent,null,null);
    // name = new ObjectName("Channel:name=replyChannel_1");
    // JmxChannelMBean replyChannel_1 = (JmxChannelMBean)
    // MBeanServerInvocationHandler.newProxyInstance(mbs, name,
    // JmxChannelMBean.class, false);
    // replyChannel_1.addNotificationListener(agent,null,null);
    // name = new ObjectName("Channel:name=replyChannel_2");
    // JmxChannelMBean replyChannel_2 = (JmxChannelMBean)
    // MBeanServerInvocationHandler.newProxyInstance(mbs, name,
    // JmxChannelMBean.class, false);
    // replyChannel_2.addNotificationListener(agent,null,null);
    // Thread.sleep(20000);
    // System.out.println("replyChannel_2: " + replyChannel_2);

    // // les canaux request, Reply1, Reply2
    // IChannel requestChannel = new Channel("Request Channel");
    // IChannel replyChannel_1 = new Channel("Reply Channel 1");
    // IChannel replyChannel_2 = new Channel("Reply Channel 2");

    // // Requestor 1 et Requestor 2
    // IRequestor requestor_1 = new Requestor(requestChannel,replyChannel_1);
    // IRequestor requestor_2 = new Requestor(requestChannel,replyChannel_2);

    // // Replier avec un dlai de garde de 10 sec
    // IReplier replier = new Replier(requestChannel, 10000);

    // IMessage message1 = new Message("message_1", replyChannel_1, 1L);
    // IMessage message2 = new Message("message_2", replyChannel_2, 2L);

    // System.out.println("Envoi de " + message2 + " depuis requestor_2" );
    // requestor_2.send(message2);
    // System.out.println("Envoi de " + message1 + " depuis requestor_1" );
    // requestor_1.send(message1);
    // Thread.sleep(2000); // attente de quelques secondes
    // IMessage received = requestor_1.receive(10000);
    // System.out.println("\n\tRception de " + received + " par requestor_1");
    // assertEquals("message_1", received.getContent().toString());
    // assertEquals(1L, received.getCorrelationId());

    // received = requestor_2.receive(10000);
    // System.out.println("\n\tRception de " + received + " par requestor_2");
    // assertEquals("message_2", received.getContent().toString());
    // assertEquals(2L, received.getCorrelationId());            

    // Thread.sleep(Integer.MAX_VALUE);
    // }
}