package question3;

import javax.management.*;
import java.lang.management.*;
import question1.*;

public class JmxChannelAgent implements NotificationListener{

    private static MBeanServer mbs;
    private JmxChannelMBean mbean;
    private Channel requestChannel = new ChannelImpl();
    private Channel replyChannel_1 = new ChannelImpl();
    private Channel replyChannel_2 = new ChannelImpl();

    public JmxChannelAgent(){
        try{
            mbs = ManagementFactory.getPlatformMBeanServer();
            this.requestChannel = new ChannelImpl();
            ObjectName name = new ObjectName("Channel:name=requestChannel");
            this.mbean = new JmxChannel(requestChannel);
            mbs.registerMBean(mbean, name); // enregistrement

            name = new ObjectName("Channel:name=replyChannel_1");
            this.replyChannel_1 = new ChannelImpl();
            this.mbean = new JmxChannel(replyChannel_1);
            mbs.registerMBean(mbean, name); // enregistrement

            name = new ObjectName("Channel:name=replyChannel_2");
            this.replyChannel_1 = new ChannelImpl();
            this.mbean = new JmxChannel(replyChannel_1);
            mbs.registerMBean(mbean, name); // enregistrement

        }catch(Exception e){
        }  
    }

    public void handleNotification( Notification notification, Object handback){
        System.out.println("notification " + notification);
    }

    public static void main(String[] args)throws Exception{ 
        JmxChannelAgent agent = new JmxChannelAgent();
        Thread.sleep(10000); // attente de une seconde
        ObjectName name = new ObjectName("Channel:name=requestChannel");
        JmxChannelMBean requestChannel = (JmxChannelMBean)
            MBeanServerInvocationHandler.newProxyInstance(mbs, name,
                JmxChannelMBean.class, false);
        requestChannel.addNotificationListener(agent,null,null);
        name = new ObjectName("Channel:name=replyChannel_1");
        JmxChannelMBean replyChannel_1 = (JmxChannelMBean)
            MBeanServerInvocationHandler.newProxyInstance(mbs, name,
                JmxChannelMBean.class, false);
        replyChannel_1.addNotificationListener(agent,null,null);
        name = new ObjectName("Channel:name=replyChannel_2");
        JmxChannelMBean replyChannel_2 = (JmxChannelMBean)
            MBeanServerInvocationHandler.newProxyInstance(mbs, name,
                JmxChannelMBean.class, false);
        replyChannel_2.addNotificationListener(agent,null,null);
        Thread.sleep(20000);
        System.out.println("replyChannel_2: " + replyChannel_2);
        
        // Channel requestChannel = new ChannelImpl();
        // Channel replyChannel_1 = new ChannelImpl();
        // Channel replyChannel_2 = new ChannelImpl();

        // Requestor 1 et Requestor 2
        Requestor requestor_1 = new RequestorImpl(requestChannel,replyChannel_1);
        Requestor requestor_2 = new RequestorImpl(requestChannel,replyChannel_2);

        // // Replier avec un dlai de garde de 10 sec
        Replier replier = new ReplierImpl(requestChannel, 10000);

        Message message1 = new MessageImpl("requestor 1", replyChannel_1, 1L);
        Message message2 = new MessageImpl("requestor 2", replyChannel_2, 2L);
        System.out.println("Envoi de " + message2);
        
        requestor_2.send(message2);
        Thread.sleep(2000); // attente de une seconde
        Message received = requestor_2.receive(20000);
        System.out.println("Rception aprs 2 secondes de " + received);
        assert "requestor 2".equals(received.getContent().toString());

        // System.out.println("Envoi de " + message1);
        requestor_1.send(message1);
        // Thread.sleep(20000); // attente de une seconde
        received = requestor_1.receive(20000);
        System.out.println("Rception aprs 3 secondes de " + received);
        assert "requestor 1".equals(received.getContent());
        
        Thread.sleep(Integer.MAX_VALUE);
    }
}