package question1;
import java.util.*;


public class Aggregator implements AggregatorI{
  private List<String> messages;
  private int size;
  
  /** Constructeur d'un l'agregateur.
   * @param size la taille, le nombre de messages souhait
   */
  public Aggregator(int size){
    this.messages   = new ArrayList<String>();
    this.size = size;
  }
  
  /** Envoi d'un message.
   * @param message
   * @throws Exception si le nombre de messages attendus est dj atteint, le message est sauvegard
   */
  public void send(String message) throws Exception{
    if(messages.size()==this.size){
      throw new Exception("le nombre de messages attendus est dj atteint !");
    }else{
      messages.add(0,message);
    }
  }
  
  /** Lecture des messages envoys.
   * @return une table contenant tous les messages reus.
   * @throws Exception si la lecture intervient avant le nombre de messages escompts
   */
  public String[] getMessages() throws Exception{
    if(messages.size()==this.size){
      // analogue  M[] msg = messages.toArray(new M[0])
      String[] msg = messages.toArray(new String[]{});
      messages.clear();
      return msg;
    }else{
      throw new Exception("la lecture intervient avant le nombre de messages escompts !");
    }
  }
  
  
  /** Effacement des messages. Les messages dj reus sont effacs.
   * 
   */
  public  void reset() {
      messages.clear();
  }
  
  public void setSize(int size) throws Exception{
      if(messages.size()!=0)
         throw new Exception("L'aggrgateur n'est pas vide");
    this.size = size;
  }

  /** Lecture du nombre d'lments envoys.
   */
  public int getSent(){
      return messages.size();
    }
}
