package question1;

import java.io.Serializable;
import java.util.*;

// import java.util.Map;
// import java.util.Set;
// import java.util.TreeMap;
// import java.util.TreeSet;
// import java.util.Collections;

public class Splitter implements SplitterI{
    private List<String> messages;

    public void send(String[] messagesArray) throws Exception{
        if(messages!=null && messages.size()>0) throw new Exception("tous les messages n'ont pas t lus ...");
        this.messages = new ArrayList();
        Collections.addAll(this.messages, messagesArray);
    }

    public Iterator<String> iterator(){
        return new TableIterator(messages);
    }

    private class TableIterator implements Iterator<String>{
        private int index;
        private List<String> messages;
        public TableIterator(List<String> messages){
            this.messages = messages;
            this.index = messages.size();
        }
        public boolean hasNext(){
            return index>0;
        }

        public String next(){
            index--;
            String element = messages.get(index);
            messages.remove(index);
            return element;
        }

        public void remove(){}
    }

 
    public synchronized void reset() {
        this.messages.clear();
    }

    public String[] unreadMessages() {
        String[] itemsArray = new String[messages.size()];
        return messages.toArray(itemsArray);
    }


}
