package question1;

public class SplitterAggregator {
    
    private SplitterI splitter;
    private AggregatorI aggregator;
    private CommandI command;

    public SplitterAggregator(SplitterI splitter, AggregatorI aggregator){
        this.splitter = splitter;
        this.aggregator = aggregator;
    }

    public void setCommand(CommandI command){
        this.command= command;
    }
    
    public void send(String[] messagesArray) throws Exception{
        splitter.send(messagesArray);
        aggregator.setSize(messagesArray.length);
        for(String msg : splitter){
          aggregator.send(msg);
          if(command!=null)command.execute(msg);
        }
    }
    
    public String[] getMessages() throws Exception{
        return aggregator.getMessages();
    }
          
}
