package question1;
import java.util.Iterator;

/** Le Patron Splitter 'dcoupe' le message envoy et permet une lecture squentielle
 * via un itrateur.
 */
public interface SplitterI extends Iterable<String>{

  /** Envoi d'une table de messages. 
   * @param messages la table des messages
   * @throws Exception si la table est nulle ou si depuis le dernier envoi tous les messages n'ont pas t lus. 
   */
  void send(String[] messages) throws Exception;
  
  /** Obtention d'un iterateur sur la table des messages.
   * @return un itrateur sur latable des messages non encore lus.
   */
  Iterator<String> iterator() ;
  
  /** Efface la dernire table des messages envoye. 
   */
  void reset();
  
  /** Obtention de la table des messages non encore lus. 
   */
  String[] unreadMessages();
}
